<template>
  <div class="app-container">
    <el-card class="topCard">
      <div class="topDiv">
        <div>
          <span style="margin-left: 10px">工位号：</span>
          <el-select
            v-model="stationNumberValue"
            clearable
            filterable
            placeholder="请选择工位号"
            size="small"
            style="width: 200px"
            @change="getPartName();getBatchBarcode();getAssemblyNumber()">
            <el-option
              v-for="item in stationNumber"
              :key="item.value"
              :label="item.label"
              :value="item.value"
              size="mini"/>
          </el-select>
          <span style="margin-left: 10px">产品型号：</span>
          <el-select
            v-model="engineTypeValue"
            clearable
            filterable
            placeholder="请选择机型"
            size="small"
            style="width: 240px"
            @change="getPartName();getAssemblyNumber()">
            <el-option
              v-for="item in engineType"
              :key="item.value"
              :label="item.label"
              :value="item.value"
              size="mini"/>
          </el-select>
          <span style="margin-left: 10px">零件名称：</span>
          <el-input
            v-model="materielName"
            clearable
            placeholder="零件名称"
            size="small"
            style="width: 200px;"/>
        </div>
        <div style="margin-top: 10px">
          <span style="margin-left: 10px">零件图号：</span>
          <el-input
            v-model="traceabilityCode"
            clearable
            placeholder="零件图号"
            size="small"
            style="width: 200px;"/>
          <!--          <span style="margin-left: 10px">零件名称：</span>-->
          <!--          <el-select v-model="partNameValue" placeholder="请选择零件名称" filterable clearable size="small" style="width: 200px;">-->
          <!--            <el-option-->
          <!--              v-for="item in partName"-->
          <!--              :key="item.ID"-->
          <!--              :label="item.label"-->
          <!--              :value="item.value"-->
          <!--              size="mini"/>-->
          <!--          </el-select>-->
          <span style="margin-left: 10px">时间：</span>
          <el-date-picker
            v-model="dateTime"
            :clearable="false"
            align="center"
            end-placeholder="结束日期"
            format="yyyy-MM-dd"
            range-separator="～"
            size="small"
            start-placeholder="开始日期"
            style="width: 240px;"
            type="daterange"
            value-format="yyyy-MM-dd"
            @change="getTraceabilityCode();getBatchBarcode();getAssemblyNumber()"/>
          <el-button
            icon="el-icon-search"
            plain
            size="small"
            style="margin-left: 5px"
            type="primary"
            @click="pageCurrent = 1,pageSize = 30,selectDate()">查询
          </el-button>
          <el-button icon="el-icon-download" size="small" type="info" @click="exportExcel()">Excel</el-button>
        </div>
        <el-table
          v-loading="loading"
          ref="multipleTable"
          :cell-class-name="tableRowClassName"
          :data="tableData"
          :header-cell-style="{background:'#eef1f6',color:'#606266'}"
          border
          class="main"
          element-loading-background="rgba(0, 0, 0, 0.2)"
          element-loading-spinner="el-icon-loading"
          element-loading-text="数据加载中"
          height="660px"
          size="mini"
          style="width: 100%;max-height: 700px"
          tooltip-effect="dark">
          <!--        <el-table-column :selectable="selectable" type="selection" width="45" align="center"/>-->
          <el-table-column align="center" label="序号" type="index" width="60"/>
          <el-table-column align="center" label="工位号" width="100px">
            <template slot-scope="scope">
              {{ scope.row.工位号 }}
            </template>
          </el-table-column>
          <el-table-column align="center" label="工位名称" width="300px">
            <template slot-scope="scope">
              {{ scope.row.工位名称 }}
            </template>
          </el-table-column>
          <el-table-column align="center" label="产品型号" width="120px">
            <template slot-scope="scope">
              {{ scope.row.发动机型号 }}
            </template>
          </el-table-column>
          <el-table-column align="center" label="零件图号" width="200px">
            <template slot-scope="scope">
              {{ scope.row.零件图号 }}
            </template>
          </el-table-column>
          <el-table-column align="center" label="零件名称" width="300">
            <template slot-scope="scope">
              {{ scope.row.零件名称 }}
            </template>
          </el-table-column>
          <el-table-column align="center" label="单次消耗" width="100">
            <template slot-scope="scope">
              {{ scope.row.使用数量 }}
            </template>
          </el-table-column>
          <el-table-column align="center" label="消耗总数" width="100">
            <template slot-scope="scope">
              {{ scope.row.总消耗数 }}
            </template>
          </el-table-column>
          <el-table-column align="center" label="消耗日期" min-width="150">
            <template slot-scope="scope">
              {{ scope.row.加工日期 }}
            </template>
          </el-table-column>
        </el-table>
        <div class="block" style="margin-top: 10px;">
          <el-pagination
            v-if="!loading"
            :current-page="pageCurrent"
            :page-size="pageSize"
            :page-sizes="[15, 30, 40]"
            :total="total"
            layout="total, sizes, prev, pager, next, jumper"
            @size-change="handleSizeChange"
            @current-change="handleCurrentChange"/>
        </div>
      </div>
    </el-card>
  </div>
</template>

<script>
export default {
  data() {
    return {
      traceabilityCodeArr: [], // 精确追溯码数组
      traceabilityCode: '', // 精确追溯码
      assemblyNumber: [], // 总成编号
      assemblyNumberValue: '', // 总成编号
      materielName: '', // 物料名称
      orderNumberValue: '', // 订单号
      orderNumber: [], // 订单号
      stationNumberValue: '', // 工位号
      stationNumber: [], // 工位号
      measuringPosition: [], // 测量位置
      measuringPositionValue: '', // 测量位置
      measuringProject: [], // 测量项目
      measuringProjectValue: '', // 测量项目
      engineTypeValue: '', // 机型
      engineType: [], // 机型
      batchBarcode: [], // 批次条码
      batchBarcodeValue: '', // 批次条码
      partName: [], // 零件名称
      partNameValue: '', // 零件名称
      isQualified: [
        {
          label: '合格',
          value: 1
        }, {
          label: '不合格',
          value: 2
        }, {
          label: '全部',
          value: 0
        }
      ], // 是否合格
      isQualifiedValue: 1, // 是否合格
      dateTime: '', // 时间
      loading: false, // 时间
      tableData: [], // 时间
      date: new Date(),
      timer: '',
      total: 0, // 总条数
      pageList: 30, // 每页显示条数
      pageSize: 30, // 每页显示条数
      pageCurrent: 1 // 后台获取页
    }
  },
  created() {
    var year, month, day, audiTime
    this.date = new Date() // 修改数据date
    year = new Date().getFullYear()
    month = new Date().getMonth() + 1 < 10 ? '0' + (new Date().getMonth() + 1) : new Date().getMonth() + 1
    day = new Date().getDate() < 10 ? '0' + new Date().getDate() : new Date().getDate()
    audiTime = year + '-' + month + '-' + day
    console.log(audiTime, 'audiTime')
    this.dateTime = [audiTime, audiTime]
    this.getStationNumber()
    this.getEngineType()
    this.selectDate()
  },
  mounted() {
  },
  methods: {
    // 表格颜色变化
    tableRowClassName({ row, rowIndex }) {
      // console.log(row, rowIndex)
      if (rowIndex % 2 === 0) {
        return 'black'
      } else {
        return 'red'
      }
    },
    // 修改物料值
    updateValue(row) {
      this.$prompt('请输入修改后的物料值', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputValue: row.物料条码
      }).then(({ value }) => {
        var param = []
        param.push(['ID', row.ID])
        param.push(['物料条码', value])
        var Data = this.CreateData('11', 'MES_装配数据_零部件追溯_修改码值', param)
        this.ExecDatabase(Data).then(response => {
          if (response.data[0].result == 1) {
            this.$message({
              type: 'success',
              message: '修改成功'
            })
            this.selectDate()
          } else {
            this.$message.error('修改失败！')
          }
        })
      })
    },
    // 工位号
    getStationNumber() {
      this.stationNumber = []
      var param = []
      var Data = this.CreateData('11', 'MES_计划BOM_工位与名称_查询', param)
      this.ExecDatabase(Data).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.stationNumber.push({
            label: response.data[i].工位号,
            value: response.data[i].工位号
          })
        }
      }).then(() => {
      })
    },
    // 机型
    getEngineType() {
      this.engineType = []
      var param = []
      var Data = this.CreateData('11', 'MES_基本变量_机型代码_查询 ', param)
      this.ExecDatabase(Data).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.engineType.push({
            label: response.data[i].发动机型号,
            value: response.data[i].发动机型号
          })
        }
      })
    },
    // 零件名称
    getPartName() {
      this.partName = []
      var param = []
      param[0] = ['发动机型号', this.engineTypeValue]
      param[1] = ['工位号', this.stationNumberValue]
      var Data = this.CreateData('11', '电子看板装配零件_零件名称_初始化查询 ', param)
      this.ExecDatabase(Data).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.partName.push({
            label: response.data[i].零件名称,
            value: response.data[i].零件名称,
            ID: response.data[i].ID
          })
        }
      })
    },
    // 追溯
    getTraceabilityCode() {
      this.traceabilityCodeArr = []
      var engineTypeValue_check, stationNumberValue_check
      this.engineTypeValue ? engineTypeValue_check = 1 : engineTypeValue_check = 0
      this.stationNumberValue ? stationNumberValue_check = 1 : stationNumberValue_check = 0
      var param = []
      param[0] = ['开始时间', this.dateTime[0] + ' ' + '00:00:00']
      param[1] = ['结束时间', this.dateTime[1] + ' ' + '23:59:59']
      // param[0] = ['开始时间', this.dateTime[0]]
      // param[1] = ['结束时间', this.dateTime[1]]
      param[2] = ['发动机型号_ischeck', engineTypeValue_check]
      param[3] = ['发动机型号', this.engineTypeValue]
      param[4] = ['工位号_ischeck', stationNumberValue_check]
      param[5] = ['工位号', this.stationNumberValue]
      param[6] = ['分线总线', 1]
      var Data = this.CreateData('11', '初始化二维码_查询 ', param)
      this.ExecDatabase(Data).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.traceabilityCodeArr.push({
            label: response.data[i].物料条码,
            value: response.data[i].物料条码,
            ID: response.data[i].ID
          })
        }
      })
    },
    getAssemblyNumber() {
      this.assemblyNumber = []
      var engineTypeValue_check, stationNumberValue_check
      this.engineTypeValue ? engineTypeValue_check = 1 : engineTypeValue_check = 0
      this.stationNumberValue ? stationNumberValue_check = 1 : stationNumberValue_check = 0
      var param = []
      param[0] = ['开始时间', this.dateTime[0] + ' ' + '00:00:00']
      param[1] = ['结束时间', this.dateTime[1] + ' ' + '23:59:59']
      // param[0] = ['开始时间', this.dateTime[0]]
      // param[1] = ['结束时间', this.dateTime[1]]
      param[2] = ['发动机型号_ischeck', engineTypeValue_check]
      param[3] = ['发动机型号', this.engineTypeValue]
      param[4] = ['工位号_ischeck', stationNumberValue_check]
      param[5] = ['工位号', this.stationNumberValue]
      param[6] = ['分线总线', 1]
      var Data = this.CreateData('11', '测量数据合格索引_发动机号_发动机型号_查询 ', param)
      this.ExecDatabase(Data).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.assemblyNumber.push({
            label: response.data[i].发动机号,
            value: response.data[i].发动机号
          })
        }
      })
    },
    getBatchBarcode() {
      this.batchBarcode = []
      var param = []
      param[0] = ['开始时间', this.dateTime[0] + ' ' + '00:00:00']
      param[1] = ['结束时间', this.dateTime[1] + ' ' + '23:59:59']
      // param[0] = ['开始时间', this.dateTime[0]]
      // param[1] = ['结束时间', this.dateTime[1]]
      param[2] = ['工位号', this.stationNumberValue]
      var Data = this.CreateData('11', '物料数据_视图_物料条码批次号_查询 ', param)
      this.ExecDatabase(Data).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.batchBarcode.push({
            label: response.data[i].物料条码,
            value: response.data[i].物料条码
          })
        }
      })
    },
    getMeasuringPosition() {
      this.measuringPosition = []
      var param = []
      param[0] = ['工位号', this.stationNumberValue]
      var Data = this.CreateData('11', '质量数据查询_测量位置 ', param)
      this.ExecDatabase(Data).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.measuringPosition.push({
            label: response.data[i].测量位置,
            value: response.data[i].测量位置
          })
        }
      }).then(() => {
        this.getMeasuringProject()
      })
    },
    getMeasuringProject() {
      this.measuringProject = []
      var param = []
      param[0] = ['工位号', this.stationNumberValue]
      param[1] = ['测量位置', this.measuringPositionValue]
      var Data = this.CreateData('11', '质量数据查询_测量项目 ', param)
      this.ExecDatabase(Data).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.measuringProject.push({
            label: response.data[i].测量项目,
            value: response.data[i].测量项目
          })
        }
      })
    },
    selectDate() {
      this.tableData = []
      var param = []
      param[0] = ['开始时间', this.dateTime[0] + ' ' + '00:00:00']
      param[1] = ['结束时间', this.dateTime[1] + ' ' + '23:59:59']
      param[2] = ['PageCurrent', this.pageCurrent]
      param[3] = ['PageSize', this.pageSize]
      param[4] = ['PageCount', '1111', 'int', '1']
      param[5] = ['ItemCount', '1111', 'int', '1']
      param[6] = ['工位号', this.stationNumberValue]
      param[7] = ['产品型号', this.engineTypeValue]
      param[8] = ['零件名称', this.materielName]
      param[9] = ['零件图号', this.traceabilityCode]
      var Data = this.CreateData('11', 'MES_装配数据_零部件追溯_物料消耗统计_视图_查询', param)
      this.ExecDatabase(Data).then(response => {
        if (response.data.result.length !== 0) {
          this.tableData = response.data.result
        }
        this.total = parseInt(response.data.output[0].ItemCount)
        this.loading = false
      })
    },
    exportExcel() {
      if (this.tableData.length !== 0) {
        var param = []
        param[0] = ['开始时间', this.dateTime[0] + ' ' + '00:00:00']
        param[1] = ['结束时间', this.dateTime[1] + ' ' + '23:59:59']
        param[2] = ['PageCurrent', this.pageCurrent]
        param[3] = ['PageSize', this.pageSize]
        param[4] = ['PageCount', '1111', 'int', '1']
        param[5] = ['ItemCount', '1111', 'int', '1']
        param[6] = ['工位号', this.stationNumberValue]
        param[7] = ['产品型号', this.engineTypeValue]
        param[8] = ['零件名称', this.materielName]
        param[9] = ['零件图号', this.traceabilityCode]
        var Data = this.CreateData('2001', 'MES_装配数据_零部件追溯_物料消耗统计_视图_查询', param)
        this.exportExcel_NPOI(Data)
      } else {
        this.$message.warning('暂无数据')
      }
    },
    // 分页
    handleSizeChange(val) {
      this.pageCurrent = 1
      this.pageSize = val
      this.selectDate()
    },
    handleCurrentChange(val) {
      this.pageCurrent = val
      this.selectDate()
    }
  }
}
</script>

<style scoped>
.topCard {
  margin: 5px;
}

.topDiv {
  margin-bottom: 10px;
}
</style>
